/* sound.c */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mbctype.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include "tr68k.h"
#include "sound.h"
#include "pcm8call.h"
#include "GetPcmPath.h"


static void *pcm_ptr[TYPE_MAX][TRACK_MAX];	/* ǂݍ .PCM f[^ւ̃|C^ */
static char pcm_full_fname[TYPE_MAX][TRACK_MAX][92];	/* .CNF ɏĂ̂܂܂ .PCM t@C */

static struct {
	int note_no[TRACK_MAX];	/* ɏ note_no */
	int l_current[TRACK_MAX];	/* 'l' Ŏw肳ꂽ݂̉ */
	int volume_current[TRACK_MAX];	/* ݂̉ */
} zms_analyse;



/* .ZMS t@C */
/* Y.ZMS𐶐悤Ƃ\[XDɂȂɂ */
int SoundSaveZms (char *fname)
{
	FILE *fp;
	char note_char[] = "cdef";
	int track, type;

	if (fname == NULL)
		fp = fopen ("TEMP.ZMS", "w");
	else
		fp = fopen (fname, "w");
	if (fp == NULL)
		return (-1);

	fprintf (fp, ".comment TR-68K\n(i)\n"
	"(m9,2048)(aADPCM,9)(m10,2048)(aADPCM,10)(m11,2048)(aADPCM,11)(m12,2048)(aADPCM,12)\n"
		 "(m13,2048)(aADPCM,13)(m14,2048)(aADPCM,14)(m15,2048)(aADPCM,15)(m16,2048)(aADPCM,16)\n\n"
		);

	/* .o0c = fname.pcm */
	{
		int pcm_use[TYPE_MAX][TRACK_MAX];	/* .PCM ۂɎgpĂ邩 */
		int note_abs;

		/*  */
		for (track = 0; track < TRACK_MAX; track++) {
			for (type = 0; type < TYPE_MAX; type++) {
				pcm_use[type][track] = 0;
			}
		}

		/* ۂɎgpĂ .PCM T */
		for (track = 0; track < TRACK_MAX; track++) {
			for (note_abs = 0; note_abs < bar_max_table[bar_max] * NOTE_DISP; note_abs++) {
				if (note_volume[track][note_abs])
					pcm_use[note_type[track][note_abs]][track] = !0;
			}
		}

		/* .o0c = fname.pcm  */
		for (track = 0; track < TRACK_MAX; track++) {
			for (type = 0; type < TYPE_MAX; type++) {
				if ((pcm_ptr[type][track]) && (pcm_use[type][track]))
					fprintf (fp, ".o%d%c = %s\n", track, note_char[type], &pcm_full_fname[type][track][0]);
			}
		}
	}

	/* e| */
	fprintf (fp, "\n(t9)\tt%d\n\n", VDISP60SEC / 4 / note_tempo);

	/* gbNƂɉtf[^ */
	for (track = 0; track < TRACK_MAX; track++) {
		char volume, volume_current;
		int bar_count, note_count, note_count2;		/* 󔒂s邽߂̃JE^ */
		int note_abs;

		fprintf (fp, "(t%d)\to%d l16 v8 @d1\n\(t%d)\t[do]\n", track + 9, track, track + 9);
		volume_current = 8;

		bar_count = 0;
		note_count = note_count2 = 0;
		fprintf (fp, "(t%d)\t\t", track + 9);
		for (note_abs = 0; note_abs < bar_max_table[bar_max] * NOTE_DISP; note_abs++) {
			volume = note_volume[track][note_abs];

			if (volume) {	/*  */
#ifdef OPTIMISE_LENGTH
				int pcm_length;
				int i;
#endif
				if (volume != volume_current) {
					/* OƂ̉ʍɂĕ */
					switch (volume - volume_current) {
					case 2:
						fputs ("~~", fp);
						break;
					case 1:
						fputs ("~", fp);
						break;
					case -1:
						fputs ("_", fp);
						break;
					case -2:
						fputs ("__", fp);
						break;
					default:
						fprintf (fp, "v%d", volume);
						break;
					}
					volume_current = volume;
				}
				fprintf (fp, "%c", note_char[note_type[track][note_abs]]);
#ifdef OPTIMISE_LENGTH
				/* 16.PCMTCY=7800/55*note_tempo */
				pcm_length = pcm_size[note_type[track][note_abs]][track] / (7800 / 55 * note_tempo);
				if (pcm_length > 3)	/* Sȏ͖点Ȃ */
					pcm_length = 3;

				/* .PCM ̒16ŕ */
				/* WȂuxvł鎖𒲂ׂ'8'o͂Ƃ */
				/* ɂ "cr" łȂ "c8" ̗lɏo͂ł */
				for (i = 0; i < pcm_length; i++) {
					if ((note_abs + i) >= (bar_max_table[bar_max] * NOTE_DISP - 1))
						break;
					if (note_volume[track][note_abs + i + 1] != 0)
						break;
				}
				switch (i) {
				case 0:
					break;
				case 1:
					fputs ("8", fp);
					break;
				case 2:
					fputs ("8.", fp);
					break;
				case 3:
					fputs ("4", fp);
					break;
				}
				note_abs += i;
				note_count += i;
#endif
			} else {
				fputs ("r", fp);
			}
			note_count++;
			if (note_count >= 4) {
				note_count -= 4;
				fputs (" ", fp);	/* 16SƂɋ󔒂 */
				note_count2++;
				if (note_count2 >= 4) {
					note_count2 -= 4;
					bar_count++;
					if (bar_count >= 2) {
						bar_count = 0;
						/* Q߂ƂɉsiŏI߂łȂ΁j */
						if (note_abs < bar_max_table[bar_max] * NOTE_DISP - 1)
							fprintf (fp, "\n(t%d)\t\t", track + 9);
					} else {
						fputs ("   ", fp);	/* SSƂɋ󔒂 */
					}
				}
			}
		}
		if (volume_current != 8)
			fprintf (fp, "v8");
		fprintf (fp, "\n(t%d)\t[loop]\n\n", track + 9);
	}
	fprintf (fp, "\n(p)\n");
	fclose (fp);

	return (0);
}



/*
   .ZMS :"(t9)" ̏ꍇ
   line_buffer ɂPsԂ .ZMS Ă̂ŁAk܂ŉ͂
   note_type[][], note_volume[][] ɏ
 */
static void LoadZmsTrack (char *line_buffer, int track, int ct)
{
	char *p = line_buffer + ct;
	unsigned char c;
	int i;

	/* (t9) s̍śE[v */
	while (c = *p++) {
		int eol_flag = 0;	/* s͏I */

		if (isspace (c))
			continue;	/* 󔒂͓ǂݔ΂ */

		if (zms_analyse.note_no[track] >= BAR_MAX * NOTE_DISP)
			break;	/* obt@ς */

		switch (c) {
		case '/':
			eol_flag = !0;	/* '/' ꂽPs͏I */
			break;

		case '[':
			while ((c = *p++) && (c != ']'));	/* ']' ܂œǂݔ΂ */
			if (!c)
				eol_flag = !0;	/* sɒB */
			break;

		case 'c':
		case 'd':
		case 'e':
		case 'f':
		case 'g':
		case 'a':
		case 'b':
			note_volume[track][zms_analyse.note_no[track]]
				= zms_analyse.volume_current[track];
			note_type[track][zms_analyse.note_no[track]] = c - 'c';
			/*  break Ȃɒ */
		case 'r':
			/* KEx̌̉wE16/8/8./4 ̂ݎw\iアcj */
			switch (*p) {
			case '1':
				if (*(p + 1) == '6') {
					zms_analyse.note_no[track]++;	/* 16 */
					p += 2;		/* "16" ̎w悤 */
				}
				break;
			case '8':
				if (*(p + 1) == '.') {
					zms_analyse.note_no[track] += 3;	/* 8. */
					p += 2;		/* "8." ̎w悤 */
				} else {
					zms_analyse.note_no[track] += 2;	/* 8 */
					p++;	/* "8" ̎w悤 */
				}
				break;
			case '4':
				zms_analyse.note_no[track] += 4;	/* 4 */
				p++;	/* "4" ̎w悤 */
				break;
			default:
				zms_analyse.note_no[track]++;	/* 16 */
				break;
			}
			break;

		case '~':
			if (zms_analyse.volume_current[track] < 15)
				zms_analyse.volume_current[track]++;
			break;

		case '_':
			if (zms_analyse.volume_current[track] > 0)
				zms_analyse.volume_current[track]--;
			break;

		case 'v':
			i = 0;
			while (isdigit (c = *p++)) {
				i *= 10;
				i += (c - '0');
			}
			p--;	/* sԂ */

			if ((i >= 0) && (i < 16))
				zms_analyse.volume_current[track] = i;
			break;

		case 't':	/* e|ύX */
			i = 0;
			while (isdigit (c = *p++)) {
				i *= 10;
				i += (c - '0');
			}
			p--;	/* sԂ */

			note_tempo = 1;
			while (i < VDISP60SEC / 4 / note_tempo)
				note_tempo++;
			break;

		case '@':
			p++;	/* @d Ȃǂ d ǂݔ΂ */
			while (isdigit (c = *p++));	/* p[^[ǂݔ΂ */
			p--;	/* sԂ */
			break;

		default:
			break;
		}
		if (eol_flag)
			break;
	}
}



/*
   .ZMS :".o0c = fname.pcm" ̏ꍇ
   Ԃl
   = 0:vIłȂG[iFłȂ.ZMSj
   < 0:G[i.PCMǂݍ߂Ȃj
 */
static int LoadZmsPcmAssign (char *line_buffer)
{
	int track, type;
	char temp_fname[94];	/* .CNF ɏĂt@C */
	char full_fname[94];	/* tpXɓWJt@C */
	FILE *fp2;

	if (!isdigit (line_buffer[2]))
		return (0);
	track = line_buffer[2] - '0';
	if (track > 7)
		return (0);

	type = line_buffer[3] - 'c';
	if ((type < 0) || (type > 3))
		return (0);

	{
		unsigned char *p = &line_buffer[4];
		unsigned char *q = temp_fname;
		int count = 0;
		char c;

		/* 󔒂 '=' ǂݔ΂ */
		while ((c = *p++) && (isspace (c) || (c == '=')));

		if (!c)		/* ȂsĂ܂H */
			return (0);
		--p;

		/* t@CRs[ */
		while ((c = *q++ = *p++) && (!isspace (c)) && (count++ < 92));

		*--q = '\0';
	}

	/* JgfBNgAϐ zmusic,zmusic0`zmusic9  .PCM t@C */
	if (!GetPcmPath (temp_fname, full_fname)) {
		printf ("t@C %s ǂݍ߂܂\n", temp_fname);
		return (-1);
	}
	fp2 = fopen (full_fname, "rb");
	if (fp2 == NULL) {
		printf ("t@C %s ǂݍ߂܂\n", temp_fname);
		return (-1);
	}
	strcpy (&pcm_full_fname[type][track][0], temp_fname);

	/* \pt@Co */
	{
		char drive[4], dir[94], fname[23], ext[23];	/* pXp */
		_splitpath (full_fname, drive, dir, fname, ext);
		strcpy (pcm_fname[type][track], fname);
		strcat (pcm_fname[type][track], ext);
	}
	fseek (fp2, 0, SEEK_END);
	pcm_size[type][track] = ftell (fp2);
	fseek (fp2, 0, SEEK_SET);

	if (pcm_ptr[type][track])	/* ɊmۂĂ */
		free (pcm_ptr[type][track]);
	pcm_ptr[type][track] = malloc (pcm_size[type][track]);
	if (pcm_ptr[type][track] == NULL) {
		printf ("PCM p܂\n");
		fclose (fp2);
		return (-1);
	}
	fread (pcm_ptr[type][track], pcm_size[type][track], 1, fp2);
	fclose (fp2);

	return (0);
}



/* .ZMS t@Cǂݍ */
int SoundLoadZms (char *fname)
{
	FILE *fp;
	int track;
#define LINE_BUFFER_SIZE	1024
	char line_buffer[LINE_BUFFER_SIZE];
	int last_track = -1;

	fp = fopen (fname, "r");
	if (fp == NULL)
		return (-1);

	/* .ZMS ͗p[N̏ */
	for (track = 0; track < TRACK_MAX; track++) {
		zms_analyse.note_no[track] = 0;
		zms_analyse.volume_current[track] = 8;
		zms_analyse.l_current[track] = 0;
	}

	/* .ZMSt@ĆEs[v */
	while (fgets (line_buffer, LINE_BUFFER_SIZE, fp)) {
		switch (line_buffer[0]) {
		case '.':
			if ((line_buffer[1] == 'o') || (line_buffer[1] == 'O')) {
				if (LoadZmsPcmAssign (line_buffer) < 0) {
					fclose (fp);
					return (-1);
				}
			}
			break;

		case '(':
			switch (line_buffer[1]) {
			case 't':	/* (t9) Ȃ */
				{
					int track;
					int ct;		/* ڂ͂邩 */
					if (!isdigit (line_buffer[2]))
						break;
					track = line_buffer[2] - '0';
					if (isdigit (line_buffer[3])) {
						track = track * 10 + (line_buffer[3] - '0');
						if (line_buffer[4] != ')')
							break;
						ct = 5;
					} else {
						if (line_buffer[3] != ')')
							break;
						ct = 4;
					}
					track -= 9;	/* (t9)`(t16)  track0`7 ɂ */
					if ((track >= 0) && (track < 8)) {
						LoadZmsTrack (line_buffer, track, ct);
						last_track = track;
					}
				}
				break;
			default:
				break;
			}
			break;

		case '\t':	/* (t9) ȗꂽ */
			if (last_track >= 0)
				LoadZmsTrack (line_buffer, last_track, 1);
			break;

		default:
			break;
		}
	}
	fclose (fp);

	/* ߐ߂ */
	bar_max = 0;
	for (track = 0; track < TRACK_MAX; track++) {
		int i;
		for (i = 0; i < BAR_MAX_TABLE; i++) {
			/* gĂ鉹𒲂ׂĂ̍őlɍ킹 */
			if (zms_analyse.note_no[track] > (bar_max_table[i] * NOTE_DISP)) {
				if (bar_max < i + 1)
					bar_max = i + 1;
			}
		}
	}

	return (0);
}



/* NɂP񂾂Ă΂ */
int SoundInit0 (char *fname)
{
	int track, type;

	for (type = 0; type < TYPE_MAX; type++) {
		for (track = 0; track < TRACK_MAX; track++) {
			pcm_fname[type][track][0] = '\0';
			pcm_ptr[type][track] = NULL;
		}
	}

	return (0);
}



/* PCM 炷 */
void SoundPcm8Out (int track, int type, int volume)
{
	/* ꉞ݂邩`FbN */
	if (pcm_ptr[type][track])
		Pcm8Play (track, (volume << 16) + 0x0403,
			  pcm_ptr[type][track], pcm_size[type][track]);
}



/* IɂP񂾂Ă΂ */
void SoundTini0 (void)
{
	int track, type;

	for (type = 0; type < TYPE_MAX; type++) {
		for (track = 0; track < TRACK_MAX; track++) {
			if (pcm_ptr[type][track])	/* ɊmۂĂ */
				free (pcm_ptr[type][track]);
		}
	}
}
